/**
 * @name csv-split-easy
 * @fileoverview Splits the CSV string into array of arrays, each representing a row of columns
 * @version 7.0.15
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/csv-split-easy/}
 */

"use strict";var csvSplitEasy=(()=>{var Ee=Object.create;var S=Object.defineProperty;var $e=Object.getOwnPropertyDescriptor;var De=Object.getOwnPropertyNames,C=Object.getOwnPropertySymbols,Fe=Object.getPrototypeOf,_=Object.prototype.hasOwnProperty,We=Object.prototype.propertyIsEnumerable;var N=(e,a,o)=>a in e?S(e,a,{enumerable:!0,configurable:!0,writable:!0,value:o}):e[a]=o,g=(e,a)=>{for(var o in a||(a={}))_.call(a,o)&&N(e,o,a[o]);if(C)for(var o of C(a))We.call(a,o)&&N(e,o,a[o]);return e};var Ce=(e,a)=>()=>(a||e((a={exports:{}}).exports,a),a.exports),_e=(e,a)=>{for(var o in a)S(e,o,{get:a[o],enumerable:!0})},B=(e,a,o,s)=>{if(a&&typeof a=="object"||typeof a=="function")for(let i of De(a))!_.call(e,i)&&i!==o&&S(e,i,{get:()=>a[i],enumerable:!(s=$e(a,i))||s.enumerable});return e};var Be=(e,a,o)=>(o=e!=null?Ee(Fe(e)):{},B(a||!e||!e.__esModule?S(o,"default",{value:e,enumerable:!0}):o,e)),Me=e=>B(S({},"__esModule",{value:!0}),e);var j=(e,a,o)=>(N(e,typeof a!="symbol"?a+"":a,o),o);var L=Ce((ut,q)=>{"use strict";q.exports=He;function b(e){return e instanceof Buffer?Buffer.from(e):new e.constructor(e.buffer.slice(),e.byteOffset,e.length)}function He(e){if(e=e||{},e.circles)return qe(e);return e.proto?s:o;function a(i,t){for(var f=Object.keys(i),n=new Array(f.length),l=0;l<f.length;l++){var r=f[l],u=i[r];typeof u!="object"||u===null?n[r]=u:u instanceof Date?n[r]=new Date(u):ArrayBuffer.isView(u)?n[r]=b(u):n[r]=t(u)}return n}function o(i){if(typeof i!="object"||i===null)return i;if(i instanceof Date)return new Date(i);if(Array.isArray(i))return a(i,o);if(i instanceof Map)return new Map(a(Array.from(i),o));if(i instanceof Set)return new Set(a(Array.from(i),o));var t={};for(var f in i)if(Object.hasOwnProperty.call(i,f)!==!1){var n=i[f];typeof n!="object"||n===null?t[f]=n:n instanceof Date?t[f]=new Date(n):n instanceof Map?t[f]=new Map(a(Array.from(n),o)):n instanceof Set?t[f]=new Set(a(Array.from(n),o)):ArrayBuffer.isView(n)?t[f]=b(n):t[f]=o(n)}return t}function s(i){if(typeof i!="object"||i===null)return i;if(i instanceof Date)return new Date(i);if(Array.isArray(i))return a(i,s);if(i instanceof Map)return new Map(a(Array.from(i),s));if(i instanceof Set)return new Set(a(Array.from(i),s));var t={};for(var f in i){var n=i[f];typeof n!="object"||n===null?t[f]=n:n instanceof Date?t[f]=new Date(n):n instanceof Map?t[f]=new Map(a(Array.from(n),s)):n instanceof Set?t[f]=new Set(a(Array.from(n),s)):ArrayBuffer.isView(n)?t[f]=b(n):t[f]=s(n)}return t}}function qe(e){var a=[],o=[];return e.proto?t:i;function s(f,n){for(var l=Object.keys(f),r=new Array(l.length),u=0;u<l.length;u++){var p=l[u],d=f[p];if(typeof d!="object"||d===null)r[p]=d;else if(d instanceof Date)r[p]=new Date(d);else if(ArrayBuffer.isView(d))r[p]=b(d);else{var m=a.indexOf(d);m!==-1?r[p]=o[m]:r[p]=n(d)}}return r}function i(f){if(typeof f!="object"||f===null)return f;if(f instanceof Date)return new Date(f);if(Array.isArray(f))return s(f,i);if(f instanceof Map)return new Map(s(Array.from(f),i));if(f instanceof Set)return new Set(s(Array.from(f),i));var n={};a.push(f),o.push(n);for(var l in f)if(Object.hasOwnProperty.call(f,l)!==!1){var r=f[l];if(typeof r!="object"||r===null)n[l]=r;else if(r instanceof Date)n[l]=new Date(r);else if(r instanceof Map)n[l]=new Map(s(Array.from(r),i));else if(r instanceof Set)n[l]=new Set(s(Array.from(r),i));else if(ArrayBuffer.isView(r))n[l]=b(r);else{var u=a.indexOf(r);u!==-1?n[l]=o[u]:n[l]=i(r)}}return a.pop(),o.pop(),n}function t(f){if(typeof f!="object"||f===null)return f;if(f instanceof Date)return new Date(f);if(Array.isArray(f))return s(f,t);if(f instanceof Map)return new Map(s(Array.from(f),t));if(f instanceof Set)return new Set(s(Array.from(f),t));var n={};a.push(f),o.push(n);for(var l in f){var r=f[l];if(typeof r!="object"||r===null)n[l]=r;else if(r instanceof Date)n[l]=new Date(r);else if(r instanceof Map)n[l]=new Map(s(Array.from(r),t));else if(r instanceof Set)n[l]=new Set(s(Array.from(r),t));else if(ArrayBuffer.isView(r))n[l]=b(r);else{var u=a.indexOf(r);u!==-1?n[l]=o[u]:n[l]=t(r)}}return a.pop(),o.pop(),n}}});var Yr={};_e(Yr,{defaults:()=>Re,splitEasy:()=>Zr,version:()=>Gr});var Pe={strictlyTwoElementsInRangeArrays:!1,progressFn:null};function h(e,a){if(!Array.isArray(e)||!e.length)return e;let o=g(g({},Pe),a),s,i;if(o.strictlyTwoElementsInRangeArrays&&!e.every((n,l)=>!Array.isArray(n)||n.length!==2?(s=l,i=n.length,!1):!0))throw new TypeError(`ranges-sort: [THROW_ID_03] The first argument should be an array and must consist of arrays which are natural number indexes representing TWO string index ranges. However, ${s}th range (${JSON.stringify(e[s],null,4)}) has not two but ${i} elements!`);if(!e.every((n,l)=>!Array.isArray(n)||!Number.isInteger(n[0])||n[0]<0||!Number.isInteger(n[1])||n[1]<0?(s=l,!1):!0))throw new TypeError(`ranges-sort: [THROW_ID_04] The first argument should be an array and must consist of arrays which are natural number indexes representing string index ranges. However, ${s}th range (${JSON.stringify(e[s],null,4)}) does not consist of only natural numbers!`);let t=e.length**2,f=0;return Array.from(e).sort((n,l)=>(o.progressFn&&(f+=1,o.progressFn(Math.floor(f*100/t))),n[0]===l[0]?n[1]<l[1]?-1:n[1]>l[1]?1:0:n[0]<l[0]?-1:1))}var M={mergeType:1,progressFn:null,joinRangesThatTouchEdges:!0};function P(e,a){function o(r){return!!r&&typeof r=="object"&&!Array.isArray(r)}if(!Array.isArray(e)||!e.length)return null;let s;if(a)if(o(a)){if(s=g(g({},M),a),s.progressFn&&o(s.progressFn)&&!Object.keys(s.progressFn).length)s.progressFn=null;else if(s.progressFn&&typeof s.progressFn!="function")throw new Error(`ranges-merge: [THROW_ID_01] opts.progressFn must be a function! It was given of a type: "${typeof s.progressFn}", equal to ${JSON.stringify(s.progressFn,null,4)}`);if(![1,2,"1","2"].includes(s.mergeType))throw new Error(`ranges-merge: [THROW_ID_02] opts.mergeType was customised to a wrong thing! It was given of a type: "${typeof s.mergeType}", equal to ${JSON.stringify(s.mergeType,null,4)}`);if(typeof s.joinRangesThatTouchEdges!="boolean")throw new Error(`ranges-merge: [THROW_ID_04] opts.joinRangesThatTouchEdges was customised to a wrong thing! It was given of a type: "${typeof s.joinRangesThatTouchEdges}", equal to ${JSON.stringify(s.joinRangesThatTouchEdges,null,4)}`)}else throw new Error(`emlint: [THROW_ID_03] the second input argument must be a plain object. It was given as:
${JSON.stringify(a,null,4)} (type ${typeof a})`);else s=g({},M);let i=e.filter(r=>Array.isArray(r)).map(r=>[...r]).filter(r=>r[2]!==void 0||r[0]!==r[1]),t,f,n;s.progressFn?t=h(i,{progressFn:r=>{n=Math.floor(r/5),n!==f&&(f=n,s.progressFn(n))}}):t=h(i);let l=t.length-1;for(let r=l;r>0;r--)s.progressFn&&(n=Math.floor((1-r/l)*78)+21,n!==f&&n>f&&(f=n,s.progressFn(n))),(t[r][0]<=t[r-1][0]||!s.joinRangesThatTouchEdges&&t[r][0]<t[r-1][1]||s.joinRangesThatTouchEdges&&t[r][0]<=t[r-1][1])&&(t[r-1][0]=Math.min(t[r][0],t[r-1][0]),t[r-1][1]=Math.max(t[r][1],t[r-1][1]),t[r][2]!==void 0&&(t[r-1][0]>=t[r][0]||t[r-1][1]<=t[r][1])&&t[r-1][2]!==null&&(t[r][2]===null&&t[r-1][2]!==null?t[r-1][2]=null:t[r-1][2]!=null?+s.mergeType==2&&t[r-1][0]===t[r][0]?t[r-1][2]=t[r][2]:t[r-1][2]+=t[r][2]:t[r-1][2]=t[r][2]),t.splice(r,1),r=t.length);return t.length?t:null}var Je=!0,E="Invariant failed";function J(e,a){if(!e){if(Je)throw new Error(E);var o=typeof a=="function"?a():a,s=o?"".concat(E,": ").concat(o):E;throw new Error(s)}}function H(e,a,o){let s=0,i=0;if(arguments.length===0)throw new Error("ranges-apply: [THROW_ID_01] inputs missing!");if(typeof e!="string")throw new TypeError(`ranges-apply: [THROW_ID_02] first input argument must be a string! Currently it's: ${typeof e}, equal to: ${JSON.stringify(e,null,4)}`);if(a&&!Array.isArray(a))throw new TypeError(`ranges-apply: [THROW_ID_03] second input argument must be an array (or null)! Currently it's: ${typeof a}, equal to: ${JSON.stringify(a,null,4)}`);if(o&&typeof o!="function")throw new TypeError(`ranges-apply: [THROW_ID_04] the third input argument must be a function (or falsey)! Currently it's: ${typeof o}, equal to: ${JSON.stringify(o,null,4)}`);if(!(a!=null&&a.filter(u=>u).length))return e;let t;Array.isArray(a)&&Number.isInteger(a[0])&&Number.isInteger(a[1])?t=[Array.from(a)]:t=Array.from(a);let f=t.length,n=0;t.filter(u=>u).forEach((u,p)=>{if(o&&(s=Math.floor(n/f*10),s!==i&&(i=s,o(s))),!Array.isArray(u))throw new TypeError(`ranges-apply: [THROW_ID_05] ranges array, second input arg., has ${p}th element not an array: ${JSON.stringify(u,null,4)}, which is ${typeof u}`);if(!Number.isInteger(u[0])){if(!Number.isInteger(+u[0])||+u[0]<0)throw new TypeError(`ranges-apply: [THROW_ID_06] ranges array, second input arg. has ${p}th element, array ${JSON.stringify(u,null,0)}. Its first element is not an integer, string index, but ${typeof u[0]}, equal to: ${JSON.stringify(u[0],null,4)}.`);t[p][0]=+t[p][0]}if(!Number.isInteger(u[1])){if(!Number.isInteger(+u[1])||+u[1]<0)throw new TypeError(`ranges-apply: [THROW_ID_07] ranges array, second input arg. has ${p}th element, array ${JSON.stringify(u,null,0)}. Its second element is not an integer, string index, but ${typeof u[1]}, equal to: ${JSON.stringify(u[1],null,4)}.`);t[p][1]=+t[p][1]}n+=1});let l=P(t,{progressFn:u=>{o&&(s=10+Math.floor(u/10),s!==i&&(i=s,o(s)))}});J(l);let r=l.length;if(r>0){let u=e.slice(l[r-1][1]);e=l.reduce((p,d,m,v)=>{o&&(s=20+Math.floor(m/r*80),s!==i&&(i=s,o(s)));let Ne=m===0?0:v[m-1][1],je=v[m][0];return`${p}${e.slice(Ne,je)}${v[m][2]||""}`},""),e+=u}return e}function O(e,a=1){let o="\xA0";function s(t){return Array.from(t).reverse().join("")}function i(t,f,n){let l=n?`
`:"\r",r=n?"\r":`
`;if(!t)return t;let u=0,p=0,d="";for(let m=0,v=t.length;m<v;m++)(t[m]===l||t[m]===r&&t[m-1]!==l)&&p++,`\r
`.includes(t[m])||t[m]===o?(u=0,t[m]===o?d+=t[m]:t[m]===l?p<=f&&(d+=t[m],t[m+1]===r&&(d+=t[m+1],m++)):t[m]===r&&(t==null?void 0:t[m-1])!==l&&p<=f&&(d+=t[m])):(u++,!t[m+1]&&!p&&(d+=" "));return d}if(typeof e=="string"&&e.length){let t=1;typeof+a=="number"&&Number.isInteger(+a)&&+a>=0&&(t=+a);let f="",n="";if(!e.trim())f=e;else if(!e[0].trim()){for(let l=0,r=e.length;l<r;l++)if(e[l].trim()){f=e.slice(0,l);break}}if(e.trim()&&(e.slice(-1).trim()===""||e.slice(-1)===o)){for(let l=e.length;l--;)if(e[l].trim()){n=e.slice(l+1);break}}return`${i(f,t,!1)}${e.trim()}${s(i(s(n),t,!0))}`}return e}var U=Be(L(),1);var pt=(0,U.default)();function w(e){return typeof e=="string"}function x(e){return Number.isSafeInteger(e)&&e>=0}function c(e){return e!=null}var k={mergeType:1,progressFn:null,joinRangesThatTouchEdges:!0};function Le(e,a){function o(r){return!!r&&typeof r=="object"&&!Array.isArray(r)}if(!Array.isArray(e)||!e.length)return null;let s;if(a)if(o(a)){if(s=g(g({},k),a),s.progressFn&&o(s.progressFn)&&!Object.keys(s.progressFn).length)s.progressFn=null;else if(s.progressFn&&typeof s.progressFn!="function")throw new Error(`ranges-merge: [THROW_ID_01] resolvedOpts.progressFn must be a function! It was given of a type: "${typeof s.progressFn}", equal to ${JSON.stringify(s.progressFn,null,4)}`);if(![1,2,"1","2"].includes(s.mergeType))throw new Error(`ranges-merge: [THROW_ID_02] resolvedOpts.mergeType was customised to a wrong thing! It was given of a type: "${typeof s.mergeType}", equal to ${JSON.stringify(s.mergeType,null,4)}`);if(typeof s.joinRangesThatTouchEdges!="boolean")throw new Error(`ranges-merge: [THROW_ID_04] resolvedOpts.joinRangesThatTouchEdges was customised to a wrong thing! It was given of a type: "${typeof s.joinRangesThatTouchEdges}", equal to ${JSON.stringify(s.joinRangesThatTouchEdges,null,4)}`)}else throw new Error(`emlint: [THROW_ID_03] the second input argument must be a plain object. It was given as:
${JSON.stringify(a,null,4)} (type ${typeof a})`);else s=g({},k);let i=e.filter(r=>Array.isArray(r)).map(r=>[...r]).filter(r=>r[2]!==void 0||r[0]!==r[1]),t,f,n;s.progressFn?t=h(i,{progressFn:r=>{n=Math.floor(r/5),n!==f&&(f=n,s.progressFn(n))}}):t=h(i);let l=t.length-1;for(let r=l;r>0;r--)s.progressFn&&(n=Math.floor((1-r/l)*78)+21,n!==f&&n>f&&(f=n,s.progressFn(n))),(t[r][0]<=t[r-1][0]||!s.joinRangesThatTouchEdges&&t[r][0]<t[r-1][1]||s.joinRangesThatTouchEdges&&t[r][0]<=t[r-1][1])&&(t[r-1][0]=Math.min(t[r][0],t[r-1][0]),t[r-1][1]=Math.max(t[r][1],t[r-1][1]),t[r][2]!==void 0&&(t[r-1][0]>=t[r][0]||t[r-1][1]<=t[r][1])&&t[r-1][2]!==null&&(t[r][2]===null&&t[r-1][2]!==null?t[r-1][2]=null:t[r-1][2]!=null?+s.mergeType==2&&t[r-1][0]===t[r][0]?t[r-1][2]=t[r][2]:t[r-1][2]+=t[r][2]:t[r-1][2]=t[r][2]),t.splice(r,1),r=t.length);return t.length?t:null}var Ue={limitToBeAddedWhitespace:!1,limitLinebreaksCount:1,mergeType:1},K=class{constructor(e){j(this,"ranges");j(this,"opts");let a=g(g({},Ue),e);if(a.mergeType&&a.mergeType!==1&&a.mergeType!==2)if(w(a.mergeType)&&a.mergeType.trim()==="1")a.mergeType=1;else if(w(a.mergeType)&&a.mergeType.trim()==="2")a.mergeType=2;else throw new Error(`ranges-push: [THROW_ID_02] opts.mergeType was customised to a wrong thing! It was given of a type: "${typeof a.mergeType}", equal to ${JSON.stringify(a.mergeType,null,4)}`);this.opts=a,this.ranges=[]}add(e,a,o){var t;if(e==null&&a==null)return;if(c(e)&&!c(a)){if(Array.isArray(e)){if(e.length){if(e.some(f=>Array.isArray(f))){e.forEach(f=>{Array.isArray(f)&&this.add(...f)});return}e.length&&x(+e[0])&&x(+e[1])&&this.add(...e)}return}throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_12] the first input argument, "from" is set (${JSON.stringify(e,null,0)}) but second-one, "to" is not (${JSON.stringify(a,null,0)})`)}else if(!c(e)&&c(a))throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_13] the second input argument, "to" is set (${JSON.stringify(a,null,0)}) but first-one, "from" is not (${JSON.stringify(e,null,0)})`);let s=+e,i=+a;if(x(o)&&(o=String(o)),x(s)&&x(i)){if(c(o)&&!w(o)&&!x(o))throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_08] The third argument, the value to add, was given not as string but ${typeof o}, equal to:
${JSON.stringify(o,null,4)}`);if(c(this.ranges)&&Array.isArray(this.last())&&s===this.last()[1]){if(this.last()[1]=i,this.last()[2],this.last()[2]!==null&&c(o)){let f=this.last()[2]&&this.last()[2].length&&(!((t=this.opts)!=null&&t.mergeType)||this.opts.mergeType===1)?`${this.last()[2]}${o}`:o;this.opts.limitToBeAddedWhitespace&&(f=O(f,this.opts.limitLinebreaksCount)),w(f)&&!f.length||(this.last()[2]=f)}}else{this.ranges||(this.ranges=[]);let f=o!==void 0&&!(w(o)&&!o.length)?[s,i,o&&this.opts.limitToBeAddedWhitespace?O(o,this.opts.limitLinebreaksCount):o]:[s,i];this.ranges.push(f)}}else throw x(s)&&s>=0?new TypeError(`ranges-push/Ranges/add(): [THROW_ID_10] "to" value, the second input argument, must be a natural number or zero! Currently it's of a type "${typeof i}" equal to: ${JSON.stringify(i,null,4)}`):new TypeError(`ranges-push/Ranges/add(): [THROW_ID_09] "from" value, the first input argument, must be a natural number or zero! Currently it's of a type "${typeof s}" equal to: ${JSON.stringify(s,null,4)}`)}push(e,a,o){this.add(e,a,o)}current(){return Array.isArray(this.ranges)&&this.ranges.length?(this.ranges=Le(this.ranges,{mergeType:this.opts.mergeType}),this.ranges&&this.opts.limitToBeAddedWhitespace?this.ranges.map(e=>c(e[2])?[e[0],e[1],O(e[2],this.opts.limitLinebreaksCount)]:e):this.ranges):null}wipe(){this.ranges=[]}replace(e){if(Array.isArray(e)&&e.length)if(Array.isArray(e[0])&&x(e[0][0]))this.ranges=Array.from(e);else throw new Error(`ranges-push/Ranges/replace(): [THROW_ID_11] Single range was given but we expected array of arrays! The first element, ${JSON.stringify(e[0],null,4)} should be an array and its first element should be an integer, a string index.`);else this.ranges=[]}last(){return Array.isArray(this.ranges)&&this.ranges.length?this.ranges[this.ranges.length-1]:null}};var ke=typeof global=="object"&&global&&global.Object===Object&&global,z=ke;var Ke=typeof self=="object"&&self&&self.Object===Object&&self,ze=z||Ke||Function("return this")(),V=ze;var Ve=V.Symbol,y=Ve;var Q=Object.prototype,Qe=Q.hasOwnProperty,Ge=Q.toString,T=y?y.toStringTag:void 0;function Ze(e){var a=Qe.call(e,T),o=e[T];try{e[T]=void 0;var s=!0}catch(t){}var i=Ge.call(e);return s&&(a?e[T]=o:delete e[T]),i}var G=Ze;var Ye=Object.prototype,Xe=Ye.toString;function er(e){return Xe.call(e)}var Z=er;var rr="[object Null]",tr="[object Undefined]",Y=y?y.toStringTag:void 0;function ar(e){return e==null?e===void 0?tr:rr:Y&&Y in Object(e)?G(e):Z(e)}var X=ar;function or(e){return e!=null&&typeof e=="object"}var ee=or;var sr="[object Symbol]";function fr(e){return typeof e=="symbol"||ee(e)&&X(e)==sr}var re=fr;function nr(e,a){for(var o=-1,s=e==null?0:e.length,i=Array(s);++o<s;)i[o]=a(e[o],o,e);return i}var te=nr;var ir=Array.isArray,ae=ir;var lr=1/0,oe=y?y.prototype:void 0,se=oe?oe.toString:void 0;function fe(e){if(typeof e=="string")return e;if(ae(e))return te(e,fe)+"";if(re(e))return se?se.call(e):"";var a=e+"";return a=="0"&&1/e==-lr?"-0":a}var I=fe;var ur=/\s/;function pr(e){for(var a=e.length;a--&&ur.test(e.charAt(a)););return a}var ne=pr;var mr=/^\s+/;function dr(e){return e&&e.slice(0,ne(e)+1).replace(mr,"")}var ie=dr;function gr(e,a,o,s){for(var i=e.length,t=o+(s?1:-1);s?t--:++t<i;)if(a(e[t],t,e))return t;return-1}var le=gr;function xr(e){return e!==e}var ue=xr;function cr(e,a,o){for(var s=o-1,i=e.length;++s<i;)if(e[s]===a)return s;return-1}var pe=cr;function yr(e,a,o){return a===a?pe(e,a,o):le(e,ue,o)}var R=yr;function hr(e){return e==null?"":I(e)}var me=hr;function br(e,a,o){var s=-1,i=e.length;a<0&&(a=-a>i?0:i+a),o=o>i?i:o,o<0&&(o+=i),i=a>o?0:o-a>>>0,a>>>=0;for(var t=Array(i);++s<i;)t[s]=e[s+a];return t}var de=br;function wr(e,a,o){var s=e.length;return o=o===void 0?s:o,!a&&o>=s?e:de(e,a,o)}var ge=wr;var vr="\\ud800-\\udfff",Sr="\\u0300-\\u036f",Tr="\\ufe20-\\ufe2f",Ar="\\u20d0-\\u20ff",Or=Sr+Tr+Ar,Ir="\\ufe0e\\ufe0f",Rr="\\u200d",Nr=RegExp("["+Rr+vr+Or+Ir+"]");function jr(e){return Nr.test(e)}var xe=jr;function Er(e){return e.split("")}var ce=Er;var ye="\\ud800-\\udfff",$r="\\u0300-\\u036f",Dr="\\ufe20-\\ufe2f",Fr="\\u20d0-\\u20ff",Wr=$r+Dr+Fr,Cr="\\ufe0e\\ufe0f",_r="["+ye+"]",$="["+Wr+"]",D="\\ud83c[\\udffb-\\udfff]",Br="(?:"+$+"|"+D+")",he="[^"+ye+"]",be="(?:\\ud83c[\\udde6-\\uddff]){2}",we="[\\ud800-\\udbff][\\udc00-\\udfff]",Mr="\\u200d",ve=Br+"?",Se="["+Cr+"]?",Pr="(?:"+Mr+"(?:"+[he,be,we].join("|")+")"+Se+ve+")*",Jr=Se+ve+Pr,Hr="(?:"+[he+$+"?",$,be,we,_r].join("|")+")",qr=RegExp(D+"(?="+D+")|"+Hr+Jr,"g");function Lr(e){return e.match(qr)||[]}var Te=Lr;function Ur(e){return xe(e)?Te(e):ce(e)}var F=Ur;function kr(e,a){for(var o=e.length;o--&&R(a,e[o],0)>-1;);return o}var Ae=kr;function Kr(e,a){for(var o=-1,s=e.length;++o<s&&R(a,e[o],0)>-1;);return o}var Oe=Kr;function zr(e,a,o){if(e=me(e),e&&(o||a===void 0))return ie(e);if(!e||!(a=I(a)))return e;var s=F(e),i=F(a),t=Oe(s,i),f=Ae(s,i)+1;return ge(s,t,f).join("")}var W=zr;var Vr={removeThousandSeparatorsFromNumbers:!0,padSingleDecimalPlaceNumbers:!0,forceUKStyle:!1};function A(e,a){let o=!0,s=[".",",","'"," "],i;if(typeof e!="string")throw new TypeError(`string-remove-thousand-separators/remSep(): [THROW_ID_01] Input must be string! Currently it's: ${typeof e}, equal to:
${JSON.stringify(e,null,4)}`);if(a&&typeof a!="object")throw new TypeError(`string-remove-thousand-separators/remSep(): [THROW_ID_02] Options object must be a plain object! Currently it's: ${typeof a}, equal to:
${JSON.stringify(a,null,4)}`);let t=g(g({},Vr),a),f=W(e.trim(),'"');if(f==="")return f;if(+e>0&&+e<1)return e;let n=new K;for(let l=0,r=f.length;l<r;l++){if(t.removeThousandSeparatorsFromNumbers&&f[l].trim()===""&&n.add(l,l+1),t.removeThousandSeparatorsFromNumbers&&f[l]==="'"&&(n.add(l,l+1),f[l+1]==="'")){o=!1;break}if(s.includes(f[l])){if(f[l+1]!==void 0&&/^\d$/.test(f[l+1]))if(f[l+2]!==void 0)if(/^\d$/.test(f[l+2]))if(f[l+3]!==void 0)if(/^\d$/.test(f[l+3])){if(f[l+4]!==void 0&&/^\d$/.test(f[l+4])){o=!1;break}else if(t.removeThousandSeparatorsFromNumbers&&n.add(l,l+1),!i)i=f[l];else if(f[l]!==i){o=!1;break}}else{o=!1;break}else t.removeThousandSeparatorsFromNumbers&&t.forceUKStyle&&f[l]===","&&n.add(l,l+1,".");else{o=!1;break}else t.forceUKStyle&&f[l]===","&&n.add(l,l+1,"."),t.padSingleDecimalPlaceNumbers&&n.add(l+2,l+2,"0")}else if(!/^\d$/.test(f[l])){o=!1;break}}return o&&n.current()?H(f,n.current()):f}var Ie="7.0.15";var Gr=Ie,Re={removeThousandSeparatorsFromNumbers:!0,padSingleDecimalPlaceNumbers:!0,forceUKStyle:!1};function Zr(e,a){let o=0,s=0,i=[],t=[],f=!1,n=!0;if(a&&typeof a!="object")throw new Error(`csv-split-easy/split(): [THROW_ID_02] Options object must be a plain object! Currently it's of a type ${typeof a} equal to:
${JSON.stringify(a,null,4)}`);let l=g(g({},Re),a);if(typeof e!="string")throw new TypeError(`csv-split-easy/split(): [THROW_ID_04] input must be string! Currently it's: ${typeof e}, equal to: ${JSON.stringify(e,null,4)}`);if(e==="")return[[""]];e=e.trim();for(let r=0,u=e.length;r<u;r++){if(n&&e[r]!=='"'&&e[r]!==","&&e[r].trim()!==""&&(n=!1),e[r]==='"')if(f&&e[r+1]==='"')r+=1;else if(f){f=!1;let p=e.slice(o,r);p.trim()!==""&&(n=!1);let d=/""/.test(p)?p.replace(/""/g,'"'):A(p,{removeThousandSeparatorsFromNumbers:l.removeThousandSeparatorsFromNumbers,padSingleDecimalPlaceNumbers:l.padSingleDecimalPlaceNumbers,forceUKStyle:l.forceUKStyle});i.push(d)}else f=!0,o=r+1;else if(!f&&e[r]===","){if(e[r-1]!=='"'&&!f){let p=e.slice(o,r);p.trim()!==""&&(n=!1),i.push(A(p,{removeThousandSeparatorsFromNumbers:l.removeThousandSeparatorsFromNumbers,padSingleDecimalPlaceNumbers:l.padSingleDecimalPlaceNumbers,forceUKStyle:l.forceUKStyle}))}o=r+1,s&&(s=0)}else if(e[r]===`
`||e[r]==="\r"){if(!s){if(s=r,!f&&e[r-1]!=='"'){let p=e.slice(o,r);p.trim()!==""&&(n=!1),i.push(A(p,{removeThousandSeparatorsFromNumbers:l.removeThousandSeparatorsFromNumbers,padSingleDecimalPlaceNumbers:l.padSingleDecimalPlaceNumbers,forceUKStyle:l.forceUKStyle}))}n?i.length=0:t.push(i),n=!0,i=[]}o=r+1}else s&&(s=0,o=r);if(r+1===u){if(e[r]!=='"'){let p=e.slice(o,r+1);p.trim()&&(n=!1),i.push(A(p,{removeThousandSeparatorsFromNumbers:l.removeThousandSeparatorsFromNumbers,padSingleDecimalPlaceNumbers:l.padSingleDecimalPlaceNumbers,forceUKStyle:l.forceUKStyle}))}n?i=[]:t.push(i),n=!0}}return t.length===0?[[""]]:t}return Me(Yr);})();
/**
 * @name ranges-sort
 * @fileoverview Sort string index ranges
 * @version 6.0.11
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-sort/}
 */
/**
 * @name ranges-merge
 * @fileoverview Merge and sort string index ranges
 * @version 9.0.15
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-merge/}
 */
/**
 * @name ranges-apply
 * @fileoverview Take an array of string index ranges, delete/replace the string according to them
 * @version 7.0.15
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-apply/}
 */
/**
 * @name string-collapse-leading-whitespace
 * @fileoverview Collapse the leading and trailing whitespace of a string
 * @version 7.0.7
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-collapse-leading-whitespace/}
 */
/**
 * @name codsen-utils
 * @fileoverview Various utility functions
 * @version 1.6.4
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/codsen-utils/}
 */
/**
 * @name ranges-push
 * @fileoverview Gather string index ranges
 * @version 7.0.15
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-push/}
 */
/**
 * @name string-remove-thousand-separators
 * @fileoverview Detects and removes thousand separators (dot/comma/quote/space) from string-type digits
 * @version 7.0.15
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-remove-thousand-separators/}
 */
/*! Bundled license information:

lodash-es/lodash.js:
  (**
   * @license
   * Lodash (Custom Build) <https://lodash.com/>
   * Build: `lodash modularize exports="es" -o ./`
   * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
   * Released under MIT license <https://lodash.com/license>
   * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
   * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
   *)
*/
